<?php

class EntitytypeController extends GxController {


	public function actionView($id) {
		$this->render('view', array(
			'model' => $this->loadModel($id, 'Entitytype'),
		));
	}

	public function actionCreate() {
		$model = new Entitytype;


		if (isset($_POST['Entitytype'])) {
			$model->attributes = $_POST['Entitytype'];
			$relatedData = array(
				'has_many_feature' => $_POST['Entitytype']['has_many_feature'] === '' ? null : $_POST['Entitytype']['has_many_feature'],
				);

			if ($model->saveWithRelated($relatedData)) {
				if (Yii::app()->request->isAjaxRequest)
					Yii::app()->end();
				else
					$this->redirect(array('view', 'id' => $model->id));
			}
		}

		$this->render('create', array( 'model' => $model));
	}

	public function actionUpdate($id) {
		$model = $this->loadModel($id, 'Entitytype');


		if (isset($_POST['Entitytype'])) {
			$model->attributes = $_POST['Entitytype'];
			$relatedData = array(
				'has_many_feature' => $_POST['Entitytype']['has_many_feature'] === '' ? null : $_POST['Entitytype']['has_many_feature'],
				);

			if ($model->saveWithRelated($relatedData)) {
				$this->redirect(array('view', 'id' => $model->id));
			}
		}

		$this->render('update', array(
				'model' => $model,
				));
	}

	public function actionDelete($id) {
		if (Yii::app()->request->isPostRequest) {
			$this->loadModel($id, 'Entitytype')->delete();

			if (!Yii::app()->request->isAjaxRequest)
				$this->redirect(array('admin'));
		} else
			throw new CHttpException(400,
					Yii::t('app', 'Invalid request. Please do not repeat this request again.'));
	}

	public function actionIndex() {
		$dataProvider = new CActiveDataProvider('Entitytype');
		$this->render('index', array(
			'dataProvider' => $dataProvider,
		));
	}

	public function actionAdmin() {
		$model = new Entitytype('search');
		$model->unsetAttributes();

		if (isset($_GET['Entitytype']))
			$model->attributes = $_GET['Entitytype'];

		$this->render('admin', array(
			'model' => $model,
		));
	}

}