<?php
/* 
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of XcruderActiveForm
 *
 * @author nlac
 */
class XcruderActiveForm extends CActiveForm {
	
	public function xpActiveField($ar, $colName, $parentModelClass=null, $parentPk=null, $parentRelations=null) {
		$colValue = $ar->getAttribute($colName);
		$dbColumn = $ar->tableSchema->columns[$colName];
		
		$colType = XcruderActiveRecord::getColumnType($ar, $ar->relations(), $dbColumn);
		$columnRelationName = @$colType[1];//the relation name the column is in, eg 'has_many_feature'
		$columnRelation     = @$colType[2];//the relation array, having 3 elements
		
		$pairRelationKey = XcruderActiveRecord::getPairRelationKey($columnRelation, $parentModelClass, $parentRelations);
		$pairRelation = $pairRelationKey && $parentRelations ? $parentRelations[$pairRelationKey] : null;
		
		$isFkField = @$columnRelation[0] == 'CBelongsToRelation';
		$isFkOfCurrentRelation = $isFkField && @$pairRelation;
		$bShowPkSelector =  $isFkField && !$isFkOfCurrentRelation;

		//return '<pre>'.print_r($dbColumn,true).'</pre>';
		$dbType = $dbColumn->dbType;
		$parentModel = null;
		$htmlOptions = array('class'=>'xpfield');
		


		//Is PK ?
		if (@$dbColumn->autoIncrement || ($dbColumn->isPrimaryKey && @$colValue)) {
			//return '<span class="pk">autoIncrement</span>';
			$htmlOptions['disabled'] = 'disabled';
			$htmlOptions['class'] = 'disabled pk';
		}

		
		//Is FK ?
		if ($isFkField) {

			//eg Array ( [0] => CBelongsToRelation [1] => Entitytype [2] => id_entitytype ) 
			//columns is an FK
			
			//$htmlOptions['class'] = 'readonly clickable ' . $colType[0];

			//print_r($colType);
			//print_r($pairRelation);
			//print_r($columnRelation);echo " - $parentModelClass $colName";
			
			if ($isFkOfCurrentRelation) {
				$colValue = $parentPk;
				$ar->setAttribute($colName, $colValue);
				
				$htmlOptions['readonly'] = 'readonly';
				$htmlOptions['class'] = ' readonly ' . $colType[0];

			} else {
				$htmlOptions['class'] = 'clickable ' . $colType[0];
				$htmlOptions['title'] = 'Click here to pick a foreign key';
			}

		}
		
		if (preg_match('/^DATE/i', $dbType) > 0) {
			
			return $this->widget('zii.widgets.jui.CJuiDatePicker', array(
				'model'=>$ar,
				'attribute'=>$colName,
				'value'=>$colValue,
				'options'=>array(
					'dateFormat' => 'yy-mm-dd',
					'changeMonth' => true,
					'changeYear' => true
				),
				'htmlOptions'=>$htmlOptions
			), true);//dropDownList($ar, $colName, array_combine( $values, $values), array());
		}
		
		else
		
		if (preg_match('/^ENUM/i', $dbType) > 0) {
			$values = preg_split("/','/", preg_replace("/^enum\('|'\)$/i", "", $dbType));
			
			return $this->dropDownList($ar, $colName, array_combine( $values, $values), $htmlOptions);
		}
		
		else
		
		if (preg_match('/^(TINYINT\(1\)|BIT|BOOL)/i', $dbType) > 0) {
			return $this->checkbox($ar, $colName, $htmlOptions);
		}

		else

		if (preg_match('/TEXT/i', $dbType) > 0) {
		
			return $this->textArea($ar, $colName, $htmlOptions);

		}
		
		else		
		
		//if (preg_match('/VARCHAR|INT|REAL|TEXT|FLOAT|DOUBLE/i', $dbType) > 0) 
		{
			
			if ($bShowPkSelector) {

				//if ($columnRelation[0] == 'CBelongsToRelation') {
				//html name of the input 2b updated
				$updateInputName = get_class($ar) . '['. $dbColumn->name . ']';
				
				//we should select ONE item, no excluded rows
				$pickerInvoker = CHtml::ajax(array(
					'url' => Yii::app()->controller->createUrl('picker/index', array(
																							'pickerModelClass'=> $columnRelation[1], //eg. Entity
																							'selectableRows' => 1,
																							'fkFieldName' => $updateInputName,
																							'bShowButtons' => false,
																							'update_grid_id' => ''
																							//'parentModelClass' => $parentModelClass,
																							//'parentPk' => $parentPk
																						)),
					'update' => '#' . Yii::app()->controller->getViewId() . '_pickercontainer'
				));
				
				$htmlOptions['onclick'] = '' . $pickerInvoker;

			}
			
			$ret = $this->textField($ar, $colName, $htmlOptions);
			$ret .= $this->error($ar, $colName);
			
			return $ret;
		}
		
		return 'unimplemented field';

	}//xpActiveField
	
}
?>
